import { TextDisplay } from "components-jsx/TextDisplay";
import { Response } from "~/utils/types";

export function ApplicationContent(props: {
	response: Response;
	includeDetails?: boolean;
}) {
	const { response } = props;
	return (
		<TextDisplay>
			### Application
			<br />
			Here for
			<br />
			-# {response.hereFor.join(", ")}
			<br />
			Found through
			<br />
			-#{" "}
			{(() => {
				switch (response.foundThrough) {
					case "archive":
						return "Guild Archive/nelly.tools";
					case "tag":
						return 'Hit "Ask to Join" on a clan tag';
					case "user":
						return "User invited them\n-# **Only accept if someone is mentioned in details**";
					case "other":
						return "Something else";
					case "sold":
						return "Was sold an invite\n-# **Only the owner can interact with this application**";
				}
			})()}
			<br />
			Languages
			<br />
			-# {response.languages}
			<br />
			Can boost
			<br />
			-# {response.canBoost ? "Yes" : "No"}
			{props.includeDetails
				? `\nDetails\n-# ${response.details.replaceAll("\n", "\n-# ")}`
				: ""}
		</TextDisplay>
	);
}
