export async function selfappReq(
	path: string,
	method: "GET" | "POST" | "PUT" | "PATCH" | "DELETE",
	data?: object
) {
	const url =
		"https://discord.com/api/v9" +
		path +
		(() => {
			if (!data || method !== "GET") return "";
			// @ts-expect-error
			return `?${new URLSearchParams(data).toString()}`;
		})();

	return await fetch(url, {
		method,
		headers: {
			Authorization: process.env.USER_TOKEN!,
			...(data ? { "Content-Type": "application/json" } : {})
		},
		body: data && method !== "GET" ? JSON.stringify(data || {}) : null
	}).then((e) => e.json());
}
