import { Member } from "oceanic.js";
import { Constants } from "../Constants";

export function match(
	value: any,
	matches: {
		[key: number | string]: any;
	}
) {
	if (matches[value]) return matches[value];
	else return null;
}

export function canUser(
	member: Member,
	can: "review" | "moderate" | "manage" | "owner"
) {
	switch (can) {
		case "review":
			return (
				member.roles.some((role) =>
					[
						Constants.REVIEWER_ROLE_ID,
						Constants.MOD_ROLE_ID,
						Constants.MANAGER_ROLE_ID
					].includes(role)
				) || member.id === Constants.OWNER_ID
			);
		case "moderate":
			return (
				member.roles.some((role) =>
					[Constants.MOD_ROLE_ID, Constants.MANAGER_ROLE_ID].includes(
						role
					)
				) || member.id === Constants.OWNER_ID
			);
		case "manage":
			return (
				member.roles.some((role) =>
					[Constants.MANAGER_ROLE_ID].includes(role)
				) || member.id === Constants.OWNER_ID
			);
		case "owner":
			return member.id === Constants.OWNER_ID;
		default:
			return false;
	}
}
